//
//  SNViewController.m
//  sinaweibo_ios_sdk_demo
//
//  Created by Wade Cheng on 4/23/12.
//  Copyright (c) 2012 SINA. All rights reserved.
//

#import "VCOPViewController.h"
#import "VCOPAppDelegate.h"
#import "UploadHistoryViewController.h"
#import "QYShowResultView.h"
#import "QYPlayBackView.h"
#define kVCOPAuthData @"VCOPAuthData"

@interface VCOPViewController ()

@end

static int threadCount;


@implementation VCOPViewController
@synthesize  contentView = _contentView;
@synthesize resumeFileID;
@synthesize uploadHistory = _uploadHistory;
#pragma --
#pragma System
- (VCOPClient *)VCOPClientInstance
{
    VCOPAppDelegate *delegate = (VCOPAppDelegate *)[UIApplication sharedApplication].delegate;
    return delegate.VCOPClientInstance;
}

- (void)dealloc
{
    [_contentView release];
    [_uploadHistory release];
    [_onUploadingItem release];
    [super dealloc];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}


-(void)showPlayView:(id)sender
{
    QYPlayBackView* playBackView = [[QYPlayBackView alloc] initWithFrame:self.view.bounds];
    [self.view addSubview:playBackView];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"播放" style:UIBarButtonSystemItemPlay target:self action:@selector(showPlayView:)];
    VCOPClient *client = [self VCOPClientInstance];
    _uploadHistory = [[NSMutableArray alloc] init];
    [_uploadHistory addObjectsFromArray:[client getUploadingVideoList]];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(resumeHistory:) name:@"ResumeOneHistory" object:nil];
    
    self.title = @"爱奇艺DEMO";
    self.view.backgroundColor = [UIColor viewFlipsideBackgroundColor];
    _contentView = [[VCOPView alloc] initWithFrame:self.view.bounds target:self];
    [self.view addSubview:_contentView];
    BOOL isLogIn = [client isLoggedIn];
    [_contentView updateBtnStateWithAuthorFlag:isLogIn isUploading:NO];
}


-(void)resumeHistory:(NSNotification *)notify
{
    NSDictionary* userInfo = [notify userInfo];
    Item* item = [[Item alloc] initWithDict:userInfo];
    self.onUploadingItem = item;
    
    if (item.params==nil) {
        [self prepareParamsBeforeUpload];
        return;
    }
    [item release];
   // [self resumeButtonPressed];
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client uploadVideoWithContentOfFile:item.filePath fileType:item.fileType params:item.params threadCount:threadCount
                               willStart:^(NSString* filePath,NSString *fileId) {
                                   //将要开始上传
                                   //这里近些一些存储操作， 在客户端也要存储上传的列表。
                                   NSLog(@"willStart fileId=%@",fileId);
                                   tempSelf.onUploadingItem.fileId = fileId;
                                   [_contentView startUpload];
    }
                                progress:^(NSString *fileId, NSNumber *percent) {
                                    //上传过程中
                                    NSLog(@"....percent %f",percent.floatValue);
                                    [tempSelf.contentView updateProgress:percent.floatValue];
    }
                                complete:^(NSString* fileId, NSDictionary *videoInfo) {
                                    //上传成功结束
                                    [tempSelf.contentView uploadSucceed];
                                    [tempSelf alertViewShow:[NSString stringWithFormat:@"上传成功 fileId:%@",tempSelf.onUploadingItem.fileId] andError:nil];
    }
                                 failure:^(NSString* fileId, NSError *error) {
                                     //上传失败
                                     [tempSelf alertViewShow:@"上传失败" andError:error];
                                     NSLog(@"succeed=%@",fileId);
                                     [_contentView uploadFailed];
    }];
}


- (void)storeAuthDataWithKey:(NSString *)key value:(NSDictionary*)info
{
    //   VCOPClient *client = [self VCOPClientInstance];
    //modify by ray
    [[NSUserDefaults standardUserDefaults] setObject:info forKey:key];
    [[NSUserDefaults standardUserDefaults] synchronize];
}



#pragma 各按钮处理事件
//个人用户认证
-(void)personalButtonPressed:(UIButton *)sender
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client authorizeWithUid:@"0003"//2010552774
                     success:^(NSString* queryKey, id responseObjct){
                         // NSLog(@"success!");
                         [tempSelf storeAuthData];
                         [tempSelf alertViewShow:[tempSelf getAccessTokenInfo:client] andError:nil];
                         BOOL isUploading = NO;
                         if (tempSelf.onUploadingItem.fileId) {
                             isUploading = YES;
                         }
                         [tempSelf.contentView updateBtnStateWithAuthorFlag:YES isUploading:isUploading];
                     }
                     failure:^(NSString* queryKey, NSError* error) {
                         //NSLog(@"error.useinfo=%@",error.userInfo);
                         [tempSelf alertViewShow:[tempSelf getAccessTokenInfo:client] andError:error];
                     }];
}


//refresh Token
-(void)refrshTokenButtonPressed:(UIButton*)sender
{
    VCOPClient *client = [self VCOPClientInstance];

    //测试重新获取accessToken
    NSString* refreshToken = client.refreshToken;
    __block VCOPViewController* tempSelf = self;
    [client refreshTokenWithRefreshToken:refreshToken success:^(NSString *queryKey, id responseObjct) {
            [tempSelf storeAuthData];
            [tempSelf alertViewShow:[tempSelf getAccessTokenInfo:client] andError:nil];
    
        } failure:^(NSString *queryKey, NSError *error) {
            [tempSelf alertViewShow:[tempSelf getAccessTokenInfo:client] andError:error];
        }];
        return;
}

/*
 //企业用户授权 
 */
-(void)enterPriseAuthorzieButtonPressed:(UIButton *)sender
{
        VCOPClient *client = [self VCOPClientInstance];

    __block VCOPViewController* tempSelf = self;
    [client authorizeWithSuccess:^(NSString* queryKey, id responseObjct){
                         // NSLog(@"success!");
                         [tempSelf storeAuthData];
                         [tempSelf alertViewShow:[tempSelf getAccessTokenInfo:client] andError:nil];
                         BOOL isUploading = NO;
                         if (tempSelf.onUploadingItem.fileId) {
                             isUploading = YES;
                         }
                         [tempSelf.contentView updateBtnStateWithAuthorFlag:YES isUploading:isUploading];
                     }
                     failure:^(NSString* queryKey, NSError* error) {
                         //NSLog(@"error.useinfo=%@",error.userInfo);
                         [tempSelf alertViewShow:[tempSelf getAccessTokenInfo:client] andError:error];
                     }];
    
}


//登出
- (void)logoutButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client logOutWithSuccess:^{
        [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"VCOPAuthData"];
        BOOL isUploading = NO;
        if (tempSelf.onUploadingItem.fileId) {
            isUploading = YES;
        }
        [tempSelf.contentView updateBtnStateWithAuthorFlag:NO isUploading:isUploading];
    }];
}


//上传视频
-(void)uploadButtonPressed
{
    threadCount = [_contentView.threadNumTextField.text intValue];
    UIImagePickerController *picker=[[UIImagePickerController alloc] init];
    NSArray *mediaTypesAllowed = [UIImagePickerController availableMediaTypesForSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
    [picker setMediaTypes:mediaTypesAllowed];
    
    picker.delegate=self;
    picker.allowsEditing = NO;
    picker.sourceType=UIImagePickerControllerSourceTypeSavedPhotosAlbum;
    [self presentViewController:picker animated:YES completion:nil];
    [picker release];
}


//暂停某条上传任务
- (void)pauseButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client pauseUploadVideoWithfileId:self.onUploadingItem.fileId
                               success:^(NSString *fileId) {
         [tempSelf.contentView pauseUpload];
    } failure:^(NSString *fileId, NSError *error) {
        DebugLog(@"pauseButtonPressed error=%@",error.description);
    }];
    
    
}

//重新开始某条上传任务
-(void)resumeButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client resumeUploadWithfileId:self.onUploadingItem.fileId
                           success:^(NSString *fileId) {
                               DebugLog(@"resumeButtonPressed succeed");
                               [tempSelf.contentView startUpload];
    }
                           failure:^(NSString *fileId, NSError *error) {
                               //重新开始 失败
                               //很有可能是上一次ID没有获取到就暂停了， 所以需要重新上传，而不是继续上传
    }];
}


//取消某上传任务
-(void)cancelButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client cancelUploadWithfileId:self.onUploadingItem.fileId
                           success:^(NSString *fileId, id responseObj) {
                               //如果是批量取消，这个id用来标示取消的是哪个。
                               [tempSelf alertViewShow:@"取消成功" andError:nil];
                               [_contentView cancelUpload];

    }
                           failure:^(NSString *fileId, NSError *error) {
                               //取消任务  失败
                               [tempSelf alertViewShow:@"取消失败" andError:nil];

    }];
    
    
}


//删除某任务
-(void)deleteButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client deleteVideoByFileId:self.onUploadingItem.fileId
                        success:^(NSString *queryKey, id responseObj) {
                            [tempSelf alertViewShow:@"删除成功" andError:nil];
                            [tempSelf.contentView.deleteButton setEnabled:NO];

    }
                        failure:^(NSString *queryKey, NSError *error) {
                            [tempSelf alertViewShow:@"删除失败" andError:error];

    }];
    
}

//获取已上传视频列表
-(void)videoListsButtonPressed
{
    
    VCOPClient *client = [self VCOPClientInstance];
    NSInteger pageIndex = _contentView.pageIndex;//[_contentView.pageIndexTextField.text intValue];
    NSLog(@"_contentView.pageIndexTextField=%@",_contentView.pageIndexTextField.text);
    __block VCOPViewController* tempSelf = self;
    NSLog(@"pageIndex＝%d",pageIndex);
    [client fetchVideoInfoListWithPageIndex:pageIndex perPage:20
                                    success:^(NSString *queryKey, id responseObj) {
                                        //获取到视频列表  成功
                                        NSDictionary* resonseDict = (NSDictionary *)responseObj;
                                        NSArray* returnedArray = [resonseDict objectForKey:@"data"];
                                        NSLog(@"returnedArray=%@",returnedArray);
                                        if (returnedArray.count<=0) {
                                            [tempSelf alertViewShow:@"已无数据!" andError:nil];
                                        }else
                                        {
                                            [tempSelf alertViewShow:[returnedArray componentsJoinedByString:@","] andError:nil];

                                        }
     
                                    } failure:^(NSString *queryKey, NSError *error) {
                                        //获取到视频列表  失败
                                        [tempSelf alertViewShow:@"获取视频列表失败" andError:error];
                                    }];
}

//获取某视频信息
-(void)videoInfoButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    NSArray *fileIDS = [[NSArray alloc] initWithObjects:self.onUploadingItem.fileId, nil];
    __block VCOPViewController* tempSelf = self;
    [client fetchVideoInfoWithFileIds:fileIDS
                              success:^(NSString *queryKey, id responseObj) {
                                  NSArray *returnedArray = [(NSDictionary*)responseObj objectForKey:@"data"];
                                  [tempSelf alertViewShow:[returnedArray componentsJoinedByString:@","] andError:nil];
                              } failure:^(NSString *queryKey, NSError *error) {
                                  [tempSelf alertViewShow:@"获取视频信息失败" andError:error];
                              }];
    [fileIDS release];
}


//获取已经上传的视频数量
-(void)videoCountButtonPressed
{
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client fetchVideoListCountSuccess:^(NSString *queryKey, id responseObj) {
        NSDictionary *dataDic = (NSDictionary *)[(NSDictionary *)responseObj objectForKey:@"data"];
        NSInteger videoCount = [[dataDic objectForKey:@"count"] integerValue];
        [tempSelf alertViewShow:[NSString stringWithFormat:@"video Count:%d",videoCount] andError:nil];
    }
                               failure:^(NSString *queryKey, NSError *error) {
                                   //获取视频数量  失败
                                   [tempSelf alertViewShow:@"获取视频数量失败" andError:error];
    }];
}


//设置视频meta信息
-(void)setVideoMetaInfo:(NSDictionary*)useInfo
{
    VCOPClient * client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client setVideoMetaDataWithFileId:self.onUploadingItem.fileId params:useInfo
                               success:^(NSString *queryKey, id responseObj) {
                                    [tempSelf alertViewShow: [NSString stringWithFormat:@"设置meta信息成功: fileId=%@",queryKey] andError:nil];
                                   tempSelf.onUploadingItem.fileName = [useInfo objectForKey:@"metaName"];
                                   tempSelf.onUploadingItem.fileDesc = [useInfo objectForKey:@"metaDesc"];
                               } failure:^(NSString *queryKey, NSError *error) {
                                   [tempSelf alertViewShow:@"设置meta失败" andError:error];
                               }];
}


//获取视频播放地址
-(void)getVideoUrlButtonPressed
{
    NSString* fileId = _contentView.fileIdTextField.text;
    VCOPClient * client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;

    [client fetchVideoUrlStrWithFileId:fileId fileType:@"1" success:^(NSString *queryKey, id responseObj) {
        [tempSelf alertViewShow:[(NSDictionary*)responseObj description] andError:nil];
    } failure:^(NSString *queryKey, NSError *error) {
    }];
}


-(void)getSingleFileVideoInfoBtnPressed:(id)sender
{
    NSString* fileId = _contentView.fileIdTextField2.text;
    VCOPClient * client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    
    [client fetchSingleVideoInfoByFileId:fileId success:^(NSString *queryKey, id responseObj) {
        [tempSelf alertViewShow:[(NSDictionary*)responseObj description] andError:nil];

    } failure:^(NSString *queryKey, NSError *error) {
        [tempSelf alertViewShow:@"获取video Info 失败" andError:error];
    }];
}


//获取上传历史（本地存储）
-(void)uploadingHistoryListButtonPressed
{
    VCOPClient * client = [self VCOPClientInstance];
    UploadHistoryViewController * uploadVC = [[UploadHistoryViewController alloc ] init];
    uploadVC.uploadingHistoryArray = [client getUploadingVideoList];
    [self.navigationController pushViewController:uploadVC animated:YES];
    [uploadVC release];
}




-(void)readPlayUrlBtnPressed:(UIButton*)sender
{
    NSString* virtualStr = _contentView.virtualUrlView.text;
    [_contentView.virtualUrlView resignFirstResponder];
    VCOPClient * client = [self VCOPClientInstance];
    NSString* fileId = _contentView.filedIdView.text;
    __block VCOPViewController* tempSelf = self;
    [client fetchVideoUrlStrWithViutualUrl:virtualStr fileId:fileId
                                   success:^(NSString *queryKey, NSString *returnedurl) {
                                       [tempSelf alertViewShow: [NSString stringWithFormat:@"%@",returnedurl] andError:nil];
                                   } failure:^(NSString *queryKey, NSError *error) {
                                       [tempSelf alertViewShow:@"获取播放地址失败" andError:error];
                                   }];

}


-(void)groupDeletePressed:(id)sender
{
    NSString* fileIds = _contentView.groupFileIdsView.text;
    VCOPClient *client = [self VCOPClientInstance];
    __block VCOPViewController* tempSelf = self;
    [client deleteVideoByFileId:fileIds
                        success:^(NSString *queryKey, id responseObj) {
                            [tempSelf alertViewShow:@"删除成功" andError:nil];
                            [tempSelf.contentView.deleteButton setEnabled:NO];
                            
                        }
                        failure:^(NSString *queryKey, NSError *error) {
                            [tempSelf alertViewShow:@"删除失败" andError:error];
                        }];

}

-(void)groupqueryPressed:(id)sender
{
    NSString* fileIds = _contentView.groupFileIdsView.text;
    VCOPClient *client = [self VCOPClientInstance];
    NSArray *fileIDS = [[fileIds componentsSeparatedByString:@","] retain];
    __block VCOPViewController* tempSelf = self;
    [client fetchVideoInfoWithFileIds:fileIDS
                              success:^(NSString *queryKey, id responseObj) {
                                  NSArray *returnedArray = [(NSDictionary*)responseObj objectForKey:@"data"];
                                  [tempSelf alertViewShow:[returnedArray componentsJoinedByString:@","] andError:nil];
                              } failure:^(NSString *queryKey, NSError *error) {
                                  [tempSelf alertViewShow:@"获取视频信息失败" andError:error];
                              }];
    [fileIDS release];

}


-(void)fetchFullStatusPressed:(id)sender
{
    NSString* fileId = _contentView.fullStatusView.text;
    VCOPClient *client = [self VCOPClientInstance];
//fetchVideoFullStatusBtFileId
    __block VCOPViewController* tempSelf = self;
    [client fetchVideoFullStatusByFileId:fileId success:^(NSString *queryKey, id responseObj) {
       // NSArray *returnedArray = [(NSDictionary*)responseObj objectForKey:@"data"];
        [tempSelf alertViewShow:[(NSDictionary*)responseObj description] andError:nil];
    } failure:^(NSString *queryKey, NSError *error) {
        [tempSelf alertViewShow:@"获取视频状态失败" andError:error];

    }];
}

//SDK版本号
-(void)sdkVersionButtonPressed:(UIButton*)button
{
//    NSString* dstPath = [NSTemporaryDirectory() stringByAppendingPathComponent:@"captue.mp4"];
//    __block VCOPViewController* tempSelf = self;
//    NSDictionary* params = [NSDictionary dictionaryWithObjectsAndKeys:@"gameChatTest",@"file_name",@"just_test",@"description",nil];
//    VCOPClient *client = [self VCOPClientInstance];
//    self.onUploadingItem.params = params;
//    [client uploadVideoWithContentOfFile:dstPath fileType:@"mp4" params:params threadCount:threadCount willStart:^(NSString* filePath, NSString *fileId) {
//        //将要开始上传
//        //这里近些一些存储操作， 在客户端也要存储上传的列表。
//        NSLog(@"fileId=%@",fileId);
//        tempSelf.onUploadingItem.fileId = fileId;
//        [tempSelf.contentView startUpload];
//    } progress:^(NSString *fileId, NSNumber *percent) {
//        //上传过程中
//        [tempSelf.contentView updateProgress:percent.floatValue];
//    } complete:^(NSString* fileId, NSDictionary *videoInfo) {
//        //上传成功结束
//        [tempSelf.contentView uploadSucceed];
//        [tempSelf alertViewShow:[NSString stringWithFormat:@"上传成功 fileId:%@",tempSelf.onUploadingItem.fileId] andError:nil];
//        NSLog(@"complete fileId=%@",fileId);
//    } failure:^(NSString* fileId, NSError *error) {
//        //上传失败
//        [tempSelf alertViewShow:@"上传失败" andError:error];
//        [tempSelf.contentView uploadFailed];
//    }];
//
//    
//    return;
    NSString* sdkVersion = [VCOPClient sdkVersion];
    [button setTitle:sdkVersion forState:UIControlStateNormal];
    [button setTitle:sdkVersion forState:UIControlStateHighlighted];
}


- (void)viewDidUnload
{
    [super viewDidUnload];
}


-(void)prepareParamsBeforeUpload
{
    UIAlertView *passwordAlert = [[UIAlertView alloc] initWithTitle:@"Set Meta Info" message:@"Enter Video Name:" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"Ok", nil];
    passwordAlert.alertViewStyle = UIAlertViewStyleLoginAndPasswordInput;
    
    UITextField* metaNameTextField = [[UITextField alloc] initWithFrame:CGRectMake(10,72,263,32)];
    metaNameTextField.tag = 1001;
    metaNameTextField.borderStyle = UITextBorderStyleRoundedRect;
    metaNameTextField.keyboardAppearance = UIKeyboardAppearanceAlert;
    metaNameTextField.delegate = self;
    [metaNameTextField becomeFirstResponder];
    metaNameTextField.placeholder = @"Meta name";
    [passwordAlert addSubview:metaNameTextField];
    [metaNameTextField release];
    
    UITextField* metaDescribeTextField = [[UITextField alloc] initWithFrame:CGRectMake(10,105,263,30)];
    metaDescribeTextField.borderStyle = UITextBorderStyleRoundedRect;
    metaDescribeTextField.tag = 1002;
    metaDescribeTextField.keyboardAppearance = UIKeyboardAppearanceAlert;
    metaDescribeTextField.delegate = self;
    metaDescribeTextField.placeholder = @"Meta description";
    [passwordAlert addSubview:metaDescribeTextField];
    [metaDescribeTextField release];
    [passwordAlert show];
    [passwordAlert release];

}

#pragma mark --
#pragma mark image Picker Controller delegate
-(void) imagePickerController:(UIImagePickerController *)UIPicker didFinishPickingMediaWithInfo:(NSDictionary *) info
{    
    [UIPicker dismissViewControllerAnimated:YES completion:^{
        NSString* mediaType = [info objectForKey:UIImagePickerControllerMediaType];
        if ( [ mediaType isEqualToString:@"public.image" ]) {
        }
        else if ( [ mediaType isEqualToString:@"public.movie" ]){
            NSURL *url =  [info objectForKey:UIImagePickerControllerMediaURL];
            NSString *urlString = [url absoluteString];
            NSArray *videoArray = [urlString componentsSeparatedByString:@"."];
            NSInteger videoArrayCount = [videoArray count];
            NSString *videoName = [videoArray objectAtIndex: (videoArrayCount -2)];
            NSString *videoType = [videoArray objectAtIndex:(videoArrayCount -1)];
            NSData *videoData = [NSData dataWithContentsOfURL:url];
            NSString *videoPath = [NSString stringWithFormat:@"%@/Documents/%@.%@",NSHomeDirectory(),videoName,videoType];
            [videoData writeToFile:videoPath atomically:NO];
            Item* item = [[Item alloc] init];
            item.filePath = videoPath;
            item.fileType = videoType;
            self.onUploadingItem = item;
            [item release];
            
            self.contentView.progressView.progress = 0;
            self.contentView.progressValue.text = @"0.00";
            [self prepareParamsBeforeUpload];
        }
    }];
   
}


#pragma mark - VCOPClient Delegate

-(void) alertViewShow:(NSString *)info andError:(NSError *)error
{
    if (error != nil) {
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Error! ! !"
                                                            message:[NSString stringWithFormat:@"\"Token info:%@\" ,Error:%@", info,error]
                                                           delegate:nil cancelButtonTitle:@"Cancel"
                                                  otherButtonTitles:@"OK", nil];
        alertView.tag = 0;
        [alertView show];
        [alertView release];
    }else{
//        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Success"
//                                                            message:[NSString stringWithFormat:@"\"show info:%@\"", info]
//                                                           delegate:self cancelButtonTitle:@"Cancel"
//                                                  otherButtonTitles:@"OK", nil];
//        alertView.tag = 0;
//        [alertView show];
//        [alertView release];
//        
        QYShowResultView* showView = [[QYShowResultView alloc] initWithFrame:self.view.bounds];
        [[UIApplication sharedApplication].keyWindow addSubview:showView];
        showView.content = info;
        [showView release];
    }
}


#pragma UIAlertViewDelegate implementation
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex==0) {
        return;
    }
    UITextField* metaNameTextField = (UITextField *)[alertView viewWithTag:1001];
    UITextField* metaDescTextField = (UITextField *)[alertView viewWithTag:1002];
    NSString* metaName = metaNameTextField.text;
    if (metaName==nil || (id)metaName==[NSNull null]) {
        metaName = @"";
    }
    NSString* metaDesc = metaDescTextField.text;
    if (metaDesc==nil || (id)metaDesc==[NSNull null]) {
        metaDesc = @"";
    }
    
    /*
     file_name   固定的名字
     description  固定的名字
     */
    __block VCOPViewController* tempSelf = self;
    NSDictionary* params = [NSDictionary dictionaryWithObjectsAndKeys:@"hi",@"file_name",@"jellpo",@"description",nil];
    VCOPClient *client = [self VCOPClientInstance];
    self.onUploadingItem.params = params;
    [client uploadVideoWithContentOfFile:self.onUploadingItem.filePath fileType:self.onUploadingItem.fileType params:params threadCount:threadCount willStart:^(NSString* filePath, NSString *fileId) {
        //将要开始上传
        //这里近些一些存储操作， 在客户端也要存储上传的列表。
        NSLog(@"fileId=%@",fileId);
        tempSelf.onUploadingItem.fileId = fileId;
        [tempSelf.contentView startUpload];
    } progress:^(NSString *fileId, NSNumber *percent) {
        //上传过程中
        [tempSelf.contentView updateProgress:percent.floatValue];
    } complete:^(NSString* fileId, NSDictionary *videoInfo) {
        //上传成功结束
        [tempSelf.contentView uploadSucceed];
        [tempSelf alertViewShow:[NSString stringWithFormat:@"上传成功 fileId:%@",tempSelf.onUploadingItem.fileId] andError:nil];
        NSLog(@"complete fileId=%@",fileId);
    } failure:^(NSString* fileId, NSError *error) {
        //上传失败
        [tempSelf alertViewShow:@"上传失败" andError:error];
        [tempSelf.contentView uploadFailed];
    }];
}



-(NSString *)getAccessTokenInfo:(VCOPClient *)client
{
    return [NSString stringWithFormat:@"accessToken=%@, expireationDate=%@, refreshToken=%@",client.accessToken,client.expirationDate,client.refreshToken];
}


- (void)storeAuthData
{
    VCOPClient *client = [self VCOPClientInstance];
    
    NSDictionary *authData = [NSDictionary dictionaryWithObjectsAndKeys:
                              client.accessToken, @"AccessTokenKey",
                              client.expirationDate, @"ExpirationDateKey",
                              client.refreshToken,@"FefreshTokenKey",
                              nil
                              ];
    [[NSUserDefaults standardUserDefaults] setObject:authData forKey:@"VCOPAuthData"];
    [[NSUserDefaults standardUserDefaults] synchronize];
}



- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientatio
{
    return toInterfaceOrientatio==UIInterfaceOrientationPortrait;
}

@end
