//
//  VCOPView.m
//  iqiyi_ios_sdk_demo
//
//  Created by 苏 瑞强 on 13-4-20.
//  Copyright (c) 2013年 meiwen li. All rights reserved.
//

#import "VCOPView.h"
@implementation VCOPView
@synthesize target = _target;
@synthesize pageIndexTextField = _pageIndexTextField;
@synthesize threadNumTextField = _threadNumTextField;
@synthesize deleteButton;
@synthesize pageIndex;
@synthesize threadCount;
@synthesize progressView;
@synthesize progressValue;

- (UIButton *)buttonWithFrame:(CGRect)frame action:(SEL)action
{
    UIImage *buttonBackgroundImage = [[UIImage imageNamed:@"button_background.png"] stretchableImageWithLeftCapWidth:5 topCapHeight:5];
    UIImage *disabledButtonBackgroundImage = [[UIImage imageNamed:@"button_background_disabled.png"] stretchableImageWithLeftCapWidth:5 topCapHeight:5];
    
    UIButton *button = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
    button.frame = frame;
    [button setBackgroundImage:buttonBackgroundImage forState:UIControlStateNormal];
    [button setBackgroundImage:disabledButtonBackgroundImage forState:UIControlStateDisabled];
    [button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [button setTitleColor:[UIColor grayColor] forState:UIControlStateDisabled];
    [button addTarget:self.target action:action forControlEvents:UIControlEventTouchUpInside];
    return [button autorelease];
}

-(void)updateProgress:(float)newProgress
{
    progressView.progress = newProgress;
    progressValue.text = [NSString stringWithFormat:@"%f",newProgress];
}

- (id)initWithFrame:(CGRect)frame target:(id)target
{
    self = [super initWithFrame:frame];
    if (self) {
        //LOGO
        _target = target;
        
       scrollView=[[UIScrollView alloc]initWithFrame:CGRectMake(0,0,[UIScreen mainScreen].bounds.size.width,[UIScreen mainScreen].bounds.size.height)];
        scrollView.showsVerticalScrollIndicator=YES;
        scrollView.scrollEnabled=YES;
        scrollView.userInteractionEnabled=YES;
        scrollView.backgroundColor = [UIColor underPageBackgroundColor];
        [self addSubview:scrollView];
        scrollView.contentSize = CGSizeMake(320,2000);
    
        UIImageView *logoImageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"logo.png"]];
        logoImageView.frame = CGRectMake(50, 20, 57, 57);
        [scrollView addSubview:logoImageView];
        [logoImageView release];
        
        
        UILabel *titleLabel = [[UILabel alloc] init];
        titleLabel.text = @"iOS SDK DEMO";
        titleLabel.backgroundColor = [UIColor clearColor];
        titleLabel.font = [UIFont systemFontOfSize:18];
        titleLabel.frame = CGRectMake(130, 40, 140, 30);
        [scrollView addSubview:titleLabel];
        [titleLabel release];
        
        
        personAuthorizeButton = [self buttonWithFrame:CGRectMake(160, 100, 145, 40) action:@selector(personalButtonPressed:)];
        [personAuthorizeButton setTitle:@"Personal Authorize" forState:UIControlStateNormal];
        [personAuthorizeButton setTitle:@"Personal Authorize" forState:UIControlStateDisabled];
      //  [scrollView addSubview:personAuthorizeButton];

        //refresh Token
        refreshTokenButton = [self buttonWithFrame:CGRectMake(5, 150, 145, 40) action:@selector(refrshTokenButtonPressed:)];
        [refreshTokenButton setTitle:@"Refresh Token" forState:UIControlStateNormal];
        [refreshTokenButton setTitle:@"Refresh Token" forState:UIControlStateDisabled];
        [scrollView addSubview:refreshTokenButton];
        
        enterpriseAuthorizeButton  = [self buttonWithFrame:CGRectMake(160, 150, 145, 40) action:@selector(enterPriseAuthorzieButtonPressed:)];
        [enterpriseAuthorizeButton setTitle:@"EnterPrise" forState:UIControlStateNormal];
        [enterpriseAuthorizeButton setTitle:@"EnterPrise" forState:UIControlStateDisabled];
        [scrollView addSubview:enterpriseAuthorizeButton];
        //登出
        logoutButton = [self buttonWithFrame:CGRectMake(20, 200, 280, 40) action:@selector(logoutButtonPressed)];
        [logoutButton setTitle:@"logout" forState:UIControlStateNormal];
        [logoutButton setTitle:@"logout" forState:UIControlStateDisabled];
        [scrollView addSubview:logoutButton];
        
        uploadButton = [self buttonWithFrame:CGRectMake(140, 250, 160, 40) action:@selector(uploadButtonPressed)];
        [uploadButton setTitle:@"Upload" forState:UIControlStateNormal];
        [uploadButton setTitle:@"Upload" forState:UIControlStateDisabled];
        [scrollView addSubview:uploadButton];
        threadNumTextField = [[UITextField alloc] initWithFrame:CGRectMake(20.0f, 255.0f, 100.0f, 30.0f)];
        [threadNumTextField setBorderStyle:UITextBorderStyleRoundedRect]; //外框类型
        threadNumTextField.placeholder = @"线程数"; //默认显示的字
        threadNumTextField.autocorrectionType = UITextAutocorrectionTypeNo;
      //  threadNumTextField.keyboardType = UIKeyboardTypeNumberPad;
        threadNumTextField.autocapitalizationType = UITextAutocapitalizationTypeNone;
        threadNumTextField.tag = 1000;
        threadNumTextField.returnKeyType = UIReturnKeyDone;
        threadNumTextField.clearButtonMode = UITextFieldViewModeWhileEditing; //编辑时会出现个修改X
        threadNumTextField.delegate = self;
        threadNumTextField.enabled = NO;
        [scrollView  addSubview:threadNumTextField];
        [[NSNotificationCenter defaultCenter]
         addObserver:self
         selector:@selector(threadNumTextFieldChanged:)
         name:UITextFieldTextDidChangeNotification
         object:threadNumTextField];
        
        progressView = [[UIProgressView alloc] initWithFrame:CGRectMake(20, 305, 230, 20)];
        [scrollView addSubview:progressView];
        
        progressValue = [[UILabel alloc] init];
        progressValue.text = @"0";
        progressValue.backgroundColor = [UIColor clearColor];
        progressValue.textColor = [UIColor whiteColor];
        progressValue.font = [UIFont systemFontOfSize:15];
        progressValue.frame = CGRectMake(255, 300, 70, 20);
        progressValue.textAlignment = UITextAlignmentCenter;
        [scrollView addSubview:progressValue];
        
        pauseButton = [self buttonWithFrame:CGRectMake(20, 330, 280, 40) action:@selector(pauseButtonPressed)];
        [pauseButton setTitle:@"Pause upload" forState:UIControlStateNormal];
        [scrollView addSubview:pauseButton];
        
       resumeButton = [self buttonWithFrame:CGRectMake(20, 380, 280, 40) action:@selector(resumeButtonPressed)];
        [resumeButton setTitle:@"Resume upload" forState:UIControlStateNormal];
        [scrollView addSubview:resumeButton];
        cancelButton = [self buttonWithFrame:CGRectMake(20, 430, 280, 40) action:@selector(cancelButtonPressed)];
        [cancelButton setTitle:@"Cancel upload" forState:UIControlStateNormal];
        [scrollView addSubview:cancelButton];
        
        
        deleteButton = [self buttonWithFrame:CGRectMake(20, 480, 280, 40) action:@selector(deleteButtonPressed)];
        [deleteButton setTitle:@"Delete video" forState:UIControlStateNormal];
       [scrollView addSubview:deleteButton]; 
        videoListsButton = [self buttonWithFrame:CGRectMake(140, 540, 160, 40) action:@selector(videoListsButtonPressed)];
        [videoListsButton setTitle:@"Video lists " forState:UIControlStateNormal];
        [scrollView addSubview:videoListsButton]; 
       pageIndexTextField = [[UITextField alloc] initWithFrame:CGRectMake(20.0f, 545.0f, 100.0f, 30.0f)];
        [pageIndexTextField setBorderStyle:UITextBorderStyleRoundedRect]; //外框类型
        pageIndexTextField.placeholder = @"第x页"; //默认显示的字
        pageIndexTextField.tag = 1001;
        pageIndexTextField.autocorrectionType = UITextAutocorrectionTypeNo;
        pageIndexTextField.autocapitalizationType = UITextAutocapitalizationTypeNone;
        pageIndexTextField.returnKeyType = UIReturnKeyDone;
        pageIndexTextField.clearButtonMode = UITextFieldViewModeWhileEditing; //编辑时会出现个修改X
        pageIndexTextField.delegate = self;
        pageIndexTextField.enabled = NO;
        [[NSNotificationCenter defaultCenter]
         addObserver:self
         selector:@selector(pageIndexTextFieldChanged:)
         name:UITextFieldTextDidChangeNotification
         object:pageIndexTextField];
        [scrollView  addSubview:pageIndexTextField];
        
        videoInfoButton = [self buttonWithFrame:CGRectMake(20, 590, 280, 40) action:@selector(videoInfoButtonPressed)];
        [videoInfoButton setTitle:@"Video infos" forState:UIControlStateNormal];
         [scrollView addSubview:videoInfoButton];  
        
        videoCountButton = [self buttonWithFrame:CGRectMake(20, 640, 280, 40) action:@selector(videoCountButtonPressed)];
        [videoCountButton setTitle:@"Video count" forState:UIControlStateNormal];
        [scrollView addSubview:videoCountButton];
        
        
       setMetaButton = [self buttonWithFrame:CGRectMake(20, 690, 280, 40) action:nil];
        [setMetaButton addTarget:self action:@selector(setMetaInfoAlertViewShow) forControlEvents:UIControlEventTouchUpInside];
        [setMetaButton setTitle:@"Set metadata" forState:UIControlStateNormal];
        [scrollView addSubview:setMetaButton];
        
        UITextField* metaNameTextField = [[UITextField alloc] initWithFrame:CGRectMake(0,740,220,45)];
        self.fileIdTextField = metaNameTextField;
        [metaNameTextField release];
        self.fileIdTextField.borderStyle = UITextBorderStyleRoundedRect;
        self.fileIdTextField.placeholder = @"FileId";
        self.fileIdTextField.delegate = self;
        self.fileIdTextField.returnKeyType = UIReturnKeyDone;
        self.fileIdTextField.clearButtonMode = UITextFieldViewModeWhileEditing; //编辑时会出现个修改X

        [scrollView addSubview:self.fileIdTextField];
        getVideoUrlButton = [self buttonWithFrame:CGRectMake(232, 740, 100, 40) action:@selector(getVideoUrlButtonPressed)];
        [getVideoUrlButton setTitle:@"Get url" forState:UIControlStateNormal];
        [scrollView addSubview:getVideoUrlButton];
        
        
        sdkVersionButton = [self buttonWithFrame:CGRectMake(5, 100, 145, 40) action:@selector(sdkVersionButtonPressed:)];
        [sdkVersionButton setTitle:@"Get version" forState:UIControlStateNormal];
        [scrollView addSubview:sdkVersionButton];
         
       uploadingHistoryListButton = [self buttonWithFrame:CGRectMake(20, 790, 280, 40) action:@selector(uploadingHistoryListButtonPressed)];
        [uploadingHistoryListButton setTitle:@"Resume From History" forState:UIControlStateNormal];
        [scrollView addSubview:uploadingHistoryListButton];
        
        
        _virtualUrlView = [[UITextView alloc] initWithFrame:CGRectMake(10, 840, 110, 70)];
        //_virtualUrlView.text = @"http://data.video.qiyi.com/videos/v/20130427/2491e1c48c818c4bfa9e7b836cb444c1.mp4";
        [scrollView addSubview:_virtualUrlView];
        
        _filedIdView = [[UITextView alloc] initWithFrame:CGRectMake(125, 840, 110, 70)];
        //_filedIdView.text = @"http://data.video.qiyi.com/videos/v/20130427/2491e1c48c818c4bfa9e7b836cb444c1.mp4";
        [scrollView addSubview:_filedIdView];

        
        self.getRealPlayUrlBtn = [self buttonWithFrame:CGRectMake(232, 840, 100, 70) action:@selector(readPlayUrlBtnPressed:)];
        [self.getRealPlayUrlBtn setTitle:@"虚转真" forState:UIControlStateNormal];
        [scrollView addSubview:self.getRealPlayUrlBtn];
        
        
        UITextField* metaNameTextField2 = [[UITextField alloc] initWithFrame:CGRectMake(0,920,220,40)];
        self.fileIdTextField2 = metaNameTextField2;
        [metaNameTextField2 release];
        self.fileIdTextField2.borderStyle = UITextBorderStyleRoundedRect;
        self.fileIdTextField2.placeholder = @"FileId";
        self.fileIdTextField2.delegate = self;
        self.fileIdTextField2.returnKeyType = UIReturnKeyDone;
        self.fileIdTextField2.clearButtonMode = UITextFieldViewModeWhileEditing; //编辑时会出现个修改X
        [scrollView addSubview:self.fileIdTextField2];
        self.getSingleFileVideoInfo = [self buttonWithFrame:CGRectMake(232, 920, 100, 40) action:@selector(getSingleFileVideoInfoBtnPressed:)];
        [self.getSingleFileVideoInfo setTitle:@"视频信息" forState:UIControlStateNormal];
        [scrollView addSubview:self.getSingleFileVideoInfo];
        
        self.groupFileIdsView = [[UITextView alloc] initWithFrame:CGRectMake(0, 980, 320, 90)];
        [scrollView addSubview:self.groupFileIdsView];
        self.groupDeleteBtn = [self buttonWithFrame:CGRectMake(0, 1080, 100, 70) action:@selector(groupDeletePressed:)];
        [self.groupDeleteBtn setTitle:@"批量删除" forState:UIControlStateNormal];
        [scrollView addSubview:_groupDeleteBtn];
        self.groupQueryBtn = [self buttonWithFrame:CGRectMake(220, 1080, 100, 70) action:@selector(groupqueryPressed:)];
        [self.groupQueryBtn setTitle:@"批量查询" forState:UIControlStateNormal];
        [scrollView addSubview:self.groupQueryBtn];
        
        self.fullStatusView = [[UITextView alloc] initWithFrame:CGRectMake(0, 1170, 200, 70)];
        [scrollView addSubview:self.fullStatusView];
        self.fullStatusBtn =  [self buttonWithFrame:CGRectMake(210, 1170, 105, 70) action:@selector(fetchFullStatusPressed:)];
        [self.fullStatusBtn setTitle:@"视频状态" forState:UIControlStateNormal];
        [scrollView addSubview:self.fullStatusBtn];
    }
    return self;
}


-(void)pageIndexTextFieldChanged:(NSNotification*)notify
{
    pageIndex = pageIndexTextField.text.integerValue;
}

-(void)threadNumTextFieldChanged:(NSNotification*)notify
{
    threadCount = threadNumTextField.text.integerValue;
    //NSLog(@"threadCount=%d",threadCount);
}

-(void)updateBtnStateWithAuthorFlag:(BOOL)isAuthored isUploading:(BOOL)isUploading
{
    BOOL authValid = isAuthored;
    refreshTokenButton.enabled = authValid;
    logoutButton.enabled = authValid;
    uploadButton.enabled = authValid;
    pauseButton.enabled = authValid;
    resumeButton.enabled = authValid;
    cancelButton.enabled = authValid;
    deleteButton.enabled = authValid;
    videoInfoButton.enabled = authValid;
    _getRealPlayUrlBtn.enabled = authValid;
    setMetaButton.enabled = authValid;
    getVideoUrlButton.enabled = authValid;
    videoListsButton.enabled = authValid;
    videoCountButton.enabled = authValid;
    uploadingHistoryListButton.enabled = authValid;
    if (isUploading==NO && isAuthored) {
        pauseButton.enabled = NO;
        resumeButton.enabled = NO;
        cancelButton.enabled = NO;
        deleteButton.enabled = NO;
        //getVideoUrlButton.enabled = NO;
        videoInfoButton.enabled = NO;
        setMetaButton.enabled = NO;
    }
    threadNumTextField.enabled = authValid;
    pageIndexTextField.enabled = authValid;
}

-(void)startUpload
{
    pauseButton.enabled = YES;
    resumeButton.enabled = NO;
    cancelButton.enabled = YES;
    deleteButton.enabled = NO;
    videoInfoButton.enabled = YES;
    setMetaButton.enabled = YES;
    getVideoUrlButton.enabled = YES;
}

-(void)pauseUpload
{
    pauseButton.enabled = NO;
    resumeButton.enabled = YES;
    cancelButton.enabled = YES;
    deleteButton.enabled = NO;
    videoInfoButton.enabled = YES;
    setMetaButton.enabled = YES;
    getVideoUrlButton.enabled = YES;
}

-(void)cancelUpload
{
    pauseButton.enabled = NO;
    resumeButton.enabled = NO;
    cancelButton.enabled = NO;
    deleteButton.enabled = NO;
    videoInfoButton.enabled = YES;
    setMetaButton.enabled = YES;
    getVideoUrlButton.enabled = YES;
    progressView.progress = 0.0;
    progressValue.text = @"0";
}

-(void)uploadSucceed
{
    pauseButton.enabled = NO;
    resumeButton.enabled = NO;
    cancelButton.enabled = NO;
    deleteButton.enabled = YES;
    videoInfoButton.enabled = YES;
    setMetaButton.enabled = YES;
    getVideoUrlButton.enabled = YES;
}


-(void)uploadFailed
{
    pauseButton.enabled = NO;
    resumeButton.enabled = YES;
    cancelButton.enabled = YES;
    deleteButton.enabled = NO;
    videoInfoButton.enabled = YES;
    setMetaButton.enabled = YES;
    getVideoUrlButton.enabled = NO;
}


-(void) setMetaInfoAlertViewShow
{
    UIAlertView *passwordAlert = [[UIAlertView alloc] initWithTitle:@"Set Meta Info" message:@"Enter Video Name:" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"Ok", nil];
    passwordAlert.alertViewStyle = UIAlertViewStyleLoginAndPasswordInput;
    
    UITextField* metaNameTextField = [[UITextField alloc] initWithFrame:CGRectMake(10,72,263,32)];
    metaNameTextField.tag = 9998;
    metaNameTextField.borderStyle = UITextBorderStyleRoundedRect;
    metaNameTextField.keyboardAppearance = UIKeyboardAppearanceAlert;
    metaNameTextField.delegate = self;
    [metaNameTextField becomeFirstResponder];
    metaNameTextField.placeholder = @"Meta name";
    [passwordAlert addSubview:metaNameTextField];
    [metaNameTextField release];
    
    UITextField* metaDescribeTextField = [[UITextField alloc] initWithFrame:CGRectMake(10,105,263,30)];
    metaDescribeTextField.borderStyle = UITextBorderStyleRoundedRect;
    metaDescribeTextField.tag = 9999;
    metaDescribeTextField.keyboardAppearance = UIKeyboardAppearanceAlert;
    metaDescribeTextField.delegate = self;
    metaDescribeTextField.placeholder = @"Meta description";
    [passwordAlert addSubview:metaDescribeTextField];
    [metaDescribeTextField release];
    [passwordAlert show];
    [passwordAlert release];
}


#pragma UITextFieldDelegate implementation
- (void)textFieldDidEndEditing:(UITextField *)textField
{
    [textField resignFirstResponder];
}


- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField
{
    //NSLog(@"textField.frame=%@",NSStringFromCGRect(textField.frame));
    CGPoint offset = CGPointMake(0, textField.frame.origin.y-100);
    [scrollView setContentOffset:offset];
    return YES;
}


- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    if (textField.tag==1001) {
        pageIndex = textField.text.integerValue;
    }
    if (textField.tag==1000) {
        threadCount = textField.text.integerValue;
    }
    return YES;
}


#pragma UIAlertViewDelegate implementation
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex==0) {
        return;
    }
    UITextField* metaNameTextField = (UITextField *)[alertView viewWithTag:9998];
    UITextField* metaDescTextField = (UITextField *)[alertView viewWithTag:9999];
//    if (metaDescTextField.text==nil || metaDescTextField.text.length<=0) {
//        UIAlertView* alert = [[UIAlertView alloc] initWithTitle:@"提醒" message:@"内容不能为空" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
//        [alertView show];
//        [alertView release];
//    }
    NSString* metaName = metaNameTextField.text;
    if (metaName==nil || (id)metaName==[NSNull null]) {
        metaName = @" ";
    }
    NSString* metaDesc = metaDescTextField.text;
    if (metaDesc==nil || (id)metaDesc==[NSNull null]) {
        metaDesc = @" ";
    }
    
    /*
        file_name   固定的名字
        description  固定的名字
     */
    NSDictionary* params = [NSDictionary dictionaryWithObjectsAndKeys:metaName,@"file_name",metaDesc,@"description",nil];
    //NSLog(@"params=%@",params);
    if(self.target)
    {
        [self.target performSelector:@selector(setVideoMetaInfo:) withObject:params];
    }
}


-(void)dealloc{
    [threadNumTextField release];
    [progressView release];
    [pageIndexTextField release];
    [super dealloc];
}

@end
